using System;
using System.Drawing;
using Decal.Adapter.Support;
using Decal.Interop.Controls;

namespace Decal.Adapter.Wrappers;

public class CheckBoxWrapper : ControlWrapperBase<CheckboxClass>
{
	private EventHandler<ControlEventArgs> evtDestroy;

	private EventHandler<CheckBoxChangeEventArgs> evtChange;

	public bool Checked
	{
		get
		{
			return base.Control.Checked;
		}
		set
		{
			base.Control.Checked = value;
		}
	}

	public bool RightToLeft
	{
		get
		{
			return base.Control.RightToLeft;
		}
		set
		{
			base.Control.RightToLeft = value;
		}
	}

	public string Text
	{
		get
		{
			return base.Control.Text;
		}
		set
		{
			base.Control.Text = value;
		}
	}

	public Color TextColor
	{
		get
		{
			return Util.ColorFromBGR(base.Control.TextColor);
		}
		set
		{
			base.Control.TextColor = Util.ColorToBGR(value);
		}
	}

	public event EventHandler<CheckBoxChangeEventArgs> Change
	{
		add
		{
			if (evtChange == null)
			{
				base.Control.Change += ChangeEvent;
			}
			evtChange = (EventHandler<CheckBoxChangeEventArgs>)Delegate.Combine(evtChange, value);
		}
		remove
		{
			evtChange = (EventHandler<CheckBoxChangeEventArgs>)Delegate.Remove(evtChange, value);
			if (evtChange == null)
			{
				base.Control.Change -= ChangeEvent;
			}
		}
	}

	public event EventHandler<ControlEventArgs> Destroy
	{
		add
		{
			if (evtDestroy == null)
			{
				base.Control.Destroy += DestroyEvent;
			}
			evtDestroy = (EventHandler<ControlEventArgs>)Delegate.Combine(evtDestroy, value);
		}
		remove
		{
			evtDestroy = (EventHandler<ControlEventArgs>)Delegate.Remove(evtDestroy, value);
			if (evtDestroy == null)
			{
				base.Control.Destroy -= DestroyEvent;
			}
		}
	}

	protected override void Dispose(bool disposing)
	{
		if (disposing)
		{
			if (evtChange != null)
			{
				evtChange = (EventHandler<CheckBoxChangeEventArgs>)Delegate.Remove(evtChange, evtChange);
				base.Control.Change -= ChangeEvent;
			}
			if (evtDestroy != null)
			{
				evtDestroy = (EventHandler<ControlEventArgs>)Delegate.Remove(evtDestroy, evtDestroy);
				base.Control.Destroy -= DestroyEvent;
			}
		}
		base.Dispose(disposing);
	}

	private void ChangeEvent(int ID, bool Checked)
	{
		if (evtChange != null)
		{
			evtChange(this, new CheckBoxChangeEventArgs(ID, Checked));
		}
	}

	private void DestroyEvent(int ID)
	{
		if (evtDestroy != null)
		{
			evtDestroy(this, new ControlEventArgs(ID));
		}
	}
}
